<?php

namespace Lc\CaracoleBundle\Container\Credit;

use App\Entity\Credit\CreditHistory;
use Lc\CaracoleBundle\Builder\Credit\CreditHistoryBuilder;
use Lc\CaracoleBundle\Definition\Field\Credit\CreditHistoryFieldDefinition;
use Lc\CaracoleBundle\Factory\Credit\CreditHistoryFactory;
use Lc\CaracoleBundle\Repository\Credit\CreditHistoryRepositoryQuery;
use Lc\CaracoleBundle\Repository\Credit\CreditHistoryStore;
use Lc\CaracoleBundle\Solver\Credit\CreditHistorySolver;

class CreditHistoryContainer
{
    protected CreditHistoryFactory $factory;
    protected CreditHistoryRepositoryQuery $repositoryQuery;
    protected CreditHistoryStore $store;
    protected CreditHistoryBuilder $builder;
    protected CreditHistorySolver $solver;
    protected CreditHistoryFieldDefinition $fieldDefinition;

    public function __construct(
            CreditHistoryFactory $factory,
            CreditHistoryRepositoryQuery $repositoryQuery,
            CreditHistorySolver $solver,
            CreditHistoryStore $store,
            CreditHistoryBuilder $builder,
            CreditHistoryFieldDefinition $fieldDefinition
    ) {
        $this->factory = $factory;
        $this->repositoryQuery = $repositoryQuery;
        $this->solver = $solver;
        $this->store = $store;
        $this->builder = $builder;
        $this->fieldDefinition = $fieldDefinition;
    }

    public static function getEntityFqcn()
    {
        return CreditHistory::class;
    }

    public function getFactory(): CreditHistoryFactory
    {
        return $this->factory;
    }

    public function getRepositoryQuery(): CreditHistoryRepositoryQuery
    {
        return $this->repositoryQuery;
    }

    public function getSolver(): CreditHistorySolver
    {
        return $this->solver;
    }

    public function getStore(): CreditHistoryStore
    {
        $this->store->resetContext();

        return $this->store;
    }

    public function getBuilder(): CreditHistoryBuilder
    {
        return $this->builder;
    }

    public function getFieldDefinition(): CreditHistoryFieldDefinition
    {
        return $this->fieldDefinition;
    }
}
