<?php

namespace Lc\CaracoleBundle\Container\Merchant;

use App\Entity\Merchant\Merchant;
use Lc\CaracoleBundle\Builder\Merchant\MerchantBuilder;
use Lc\CaracoleBundle\Factory\Merchant\MerchantFactory;
use Lc\CaracoleBundle\Repository\Merchant\MerchantRepositoryQuery;
use Lc\CaracoleBundle\Repository\Merchant\MerchantStore;
use Lc\CaracoleBundle\Resolver\MerchantResolver;
use Lc\CaracoleBundle\Solver\Merchant\MerchantSolver;
use Lc\SovBundle\Solver\Setting\SettingSolver;

class MerchantContainer
{
    protected MerchantFactory $factory;
    protected MerchantSolver $solver;
    protected MerchantBuilder $builder;
    protected MerchantResolver $resolver;
    protected MerchantRepositoryQuery $repositoryQuery;
    protected MerchantStore $store;

    public function __construct(
            MerchantFactory $factory,
            MerchantSolver $solver,
            MerchantBuilder $builder,
            MerchantResolver $resolver,
            MerchantRepositoryQuery $repositoryQuery,
            MerchantStore $store
    ) {
        $this->factory = $factory;
        $this->solver = $solver;
        $this->builder = $builder;
        $this->resolver = $resolver;
        $this->repositoryQuery = $repositoryQuery;
        $this->store = $store;
    }


    public static function getEntityFqcn()
    {
        return Merchant::class;
    }

    public function getFactory(): MerchantFactory
    {
        return $this->factory;
    }

    public function getSolver(): MerchantSolver
    {
        return $this->solver;
    }

    public function getResolver(): MerchantResolver
    {
        return $this->resolver;
    }

    public function getRepositoryQuery(): MerchantRepositoryQuery
    {
        return $this->repositoryQuery;
    }

    public function getStore(): MerchantStore
    {
        return $this->store;
    }

    public function getBuilder(): MerchantBuilder
    {
        return $this->builder;
    }
}
