<?php

namespace Lc\CaracoleBundle\Container\Order;

use App\Entity\Order\OrderReductionCredit;
use Lc\CaracoleBundle\Factory\Order\OrderReductionCreditFactory;
use Lc\CaracoleBundle\Repository\Order\OrderReductionCreditRepositoryQuery;
use Lc\CaracoleBundle\Repository\Order\OrderReductionCreditStore;

class OrderReductionCreditContainer
{
    protected OrderReductionCreditFactory $factory;
    protected OrderReductionCreditRepositoryQuery $repositoryQuery;
    protected OrderReductionCreditStore $store;

    public function __construct(
            OrderReductionCreditFactory $factory,
            OrderReductionCreditRepositoryQuery $repositoryQuery,
            OrderReductionCreditStore $store
    ) {
        $this->factory = $factory;
        $this->repositoryQuery = $repositoryQuery;
        $this->store = $store;
    }


    public static function getEntityFqcn()
    {
        return OrderReductionCredit::class;
    }

    public function getFactory(): OrderReductionCreditFactory
    {
        return $this->factory;
    }

    public function getRepositoryQuery(): OrderReductionCreditRepositoryQuery
    {
        return $this->repositoryQuery;
    }

    public function getStore(): OrderReductionCreditStore
    {
        return $this->store;
    }

}
