<?php

namespace Lc\CaracoleBundle\Container\Order;

use App\Entity\Order\OrderShop;
use App\Resolver\OrderShopResolver;
use Lc\CaracoleBundle\Builder\Order\OrderShopBuilder;
use Lc\CaracoleBundle\Definition\Field\Order\OrderShopFieldDefinition;
use Lc\CaracoleBundle\Factory\Order\OrderShopFactory;
use Lc\CaracoleBundle\Repository\Order\OrderShopRepositoryQuery;
use Lc\CaracoleBundle\Repository\Order\OrderShopStore;
use Lc\CaracoleBundle\Solver\Order\OrderShopSolver;
use Lc\CaracoleBundle\Transformer\Order\OrderShopTransformer;

class OrderShopContainer
{
    protected OrderShopFactory $factory;
    protected OrderShopSolver $solver;
    protected OrderShopRepositoryQuery $repositoryQuery;
    protected OrderShopStore $store;
    protected OrderShopBuilder $builder;
    protected OrderShopResolver $resolver;
    protected OrderShopTransformer $transformer;
    protected OrderShopFieldDefinition $fieldDefinition;

    public function __construct(
            OrderShopFactory $factory,
            OrderShopSolver $solver,
            OrderShopRepositoryQuery $repositoryQuery,
            OrderShopStore $store,
            OrderShopResolver $resolver,
            OrderShopBuilder $builder,
            OrderShopTransformer $transformer,
            OrderShopFieldDefinition $fieldDefinition
    ) {
        $this->factory = $factory;
        $this->solver = $solver;
        $this->repositoryQuery = $repositoryQuery;
        $this->store = $store;
        $this->resolver = $resolver;
        $this->builder = $builder;
        $this->transformer = $transformer;
        $this->fieldDefinition = $fieldDefinition;
    }

    public static function getEntityFqcn()
    {
        return OrderShop::class;
    }

    public function getFactory(): OrderShopFactory
    {
        return $this->factory;
    }

    public function getSolver(): OrderShopSolver
    {
        return $this->solver;
    }

    public function getRepositoryQuery(): OrderShopRepositoryQuery
    {
        return $this->repositoryQuery;
    }

    public function getStore(): OrderShopStore
    {
        $this->store->resetContext();

        return $this->store;
    }

    public function getResolver(): OrderShopResolver
    {
        return $this->resolver;
    }

    public function getBuilder(): OrderShopBuilder
    {
        return $this->builder;
    }

    public function getTransformer(): OrderShopTransformer
    {
        return $this->transformer;
    }

    public function getFieldDefinition(): OrderShopFieldDefinition
    {
        return $this->fieldDefinition;
    }

}
