<?php

namespace Lc\CaracoleBundle\Container\Order;

use App\Entity\Order\OrderStatus;
use Lc\CaracoleBundle\Factory\Order\OrderStatusFactory;
use Lc\CaracoleBundle\Repository\Order\OrderStatusRepositoryQuery;
use Lc\CaracoleBundle\Repository\Order\OrderStatusStore;

class OrderStatusContainer
{
    protected OrderStatusFactory $factory;
    protected OrderStatusRepositoryQuery $repositoryQuery;
    protected OrderStatusStore $store;

    public function __construct(
            OrderStatusFactory $factory,
            OrderStatusRepositoryQuery $repositoryQuery,
            OrderStatusStore $store
    ) {
        $this->factory = $factory;
        $this->repositoryQuery = $repositoryQuery;
        $this->store = $store;
    }

    public static function getEntityFqcn()
    {
        return OrderStatus::class;
    }

    public function getFactory(): OrderStatusFactory
    {
        return $this->factory;
    }

    public function getRepositoryQuery(): OrderStatusRepositoryQuery
    {
        return $this->repositoryQuery;
    }

    public function getStore(): OrderStatusStore
    {
        return $this->store;
    }

}
