<?php

namespace Lc\CaracoleBundle\Container\Order;

use App\Entity\Order\OrderStatusHistory;
use Lc\CaracoleBundle\Factory\Order\OrderStatusHistoryFactory;
use Lc\CaracoleBundle\Repository\Order\OrderStatusHistoryRepositoryQuery;
use Lc\CaracoleBundle\Repository\Order\OrderStatusHistoryStore;

class OrderStatusHistoryContainer
{
    protected OrderStatusHistoryFactory $factory;
    protected OrderStatusHistoryRepositoryQuery $repositoryQuery;
    protected OrderStatusHistoryStore $store;

    public function __construct(
            OrderStatusHistoryFactory $factory,
            OrderStatusHistoryRepositoryQuery $repositoryQuery,
            OrderStatusHistoryStore $store
    ) {
        $this->factory = $factory;
        $this->repositoryQuery = $repositoryQuery;
        $this->store = $store;
    }

    public static function getEntityFqcn()
    {
        return OrderStatusHistory::class;
    }

    public function getFactory(): OrderStatusHistoryFactory
    {
        return $this->factory;
    }

    public function getRepositoryQuery(): OrderStatusHistoryRepositoryQuery
    {
        return $this->repositoryQuery;
    }

    public function getStore(): OrderStatusHistoryStore
    {
        return $this->store;
    }

}
