<?php

namespace Lc\CaracoleBundle\Container\PointSale;

use App\Entity\PointSale\PointSaleSection;
use Lc\CaracoleBundle\Builder\PointSale\PointSaleSectionBuilder;
use Lc\CaracoleBundle\Factory\PointSale\PointSaleSectionFactory;
use Lc\CaracoleBundle\Repository\PointSale\PointSaleSectionRepositoryQuery;
use Lc\CaracoleBundle\Repository\PointSale\PointSaleSectionStore;

class PointSaleSectionContainer
{
    protected PointSaleSectionFactory $factory;
    protected PointSaleSectionRepositoryQuery $repositoryQuery;
    protected PointSaleSectionStore $store;
    protected PointSaleSectionBuilder $builder;

    public function __construct(
            PointSaleSectionFactory $factory,
            PointSaleSectionRepositoryQuery $repositoryQuery,
            PointSaleSectionStore $store,
            PointSaleSectionBuilder $builder
    ) {
        $this->factory = $factory;
        $this->repositoryQuery = $repositoryQuery;
        $this->store = $store;
        $this->builder = $builder;
    }


    public static function getEntityFqcn()
    {
        return PointSaleSection::class;
    }
    public function getFactory(): PointSaleSectionFactory
    {
        return $this->factory;
    }

    public function getRepositoryQuery(): PointSaleSectionRepositoryQuery
    {
        return $this->repositoryQuery;
    }

    public function getStore(): PointSaleSectionStore
    {
        $this->store->resetContext();

        return $this->store;
    }

    public function getBuilder(): PointSaleSectionBuilder
    {
        return $this->builder;
    }
}
