<?php

namespace Lc\CaracoleBundle\Container\Product;

use Lc\CaracoleBundle\Factory\Product\QualityLabelFactory;
use Lc\CaracoleBundle\Model\Product\QualityLabel;
use Lc\CaracoleBundle\Repository\Product\QualityLabelRepositoryQuery;
use Lc\CaracoleBundle\Repository\Product\QualityLabelStore;

class QualityLabelContainer
{
    protected QualityLabelFactory $factory;
    protected QualityLabelRepositoryQuery $repositoryQuery;
    protected QualityLabelStore $store;

    public function __construct(
            QualityLabelFactory $factory,
            QualityLabelRepositoryQuery $repositoryQuery,
            QualityLabelStore $store
    ) {
        $this->factory = $factory;
        $this->repositoryQuery = $repositoryQuery;
        $this->store = $store;
    }


    public static function getEntityFqcn()
    {
        return QualityLabel::class;
    }

    public function getFactory(): QualityLabelFactory
    {
        return $this->factory;
    }

    public function getRepositoryQuery(): QualityLabelRepositoryQuery
    {
        return $this->repositoryQuery;
    }

    public function getStore(): QualityLabelStore
    {
        return $this->store;
    }

}
