<?php

namespace Lc\CaracoleBundle\Container\Reduction;

use App\Definition\Field\Reduction\ReductionCreditFieldDefinition;
use App\Entity\Reduction\ReductionCredit;
use Lc\CaracoleBundle\Factory\Reduction\ReductionCreditFactory;
use Lc\CaracoleBundle\Repository\Reduction\ReductionCreditRepositoryQuery;
use Lc\CaracoleBundle\Repository\Reduction\ReductionCreditStore;

class ReductionCreditContainer
{
    protected ReductionCreditFactory $factory;
    protected ReductionCreditRepositoryQuery $repositoryQuery;
    protected ReductionCreditStore $store;
    protected ReductionCreditFieldDefinition $fieldDefinition;

    public function __construct(
            ReductionCreditFactory $factory,
            ReductionCreditRepositoryQuery $repositoryQuery,
            ReductionCreditStore $store,
            ReductionCreditFieldDefinition $fieldDefinition
    ) {
        $this->factory = $factory;
        $this->repositoryQuery = $repositoryQuery;
        $this->store = $store;
        $this->fieldDefinition = $fieldDefinition;
    }


    public static function getEntityFqcn()
    {
        return ReductionCredit::class;
    }

    public function getFactory(): ReductionCreditFactory
    {
        return $this->factory;
    }

    public function getRepositoryQuery(): ReductionCreditRepositoryQuery
    {
        return $this->repositoryQuery;
    }

    public function getStore(): ReductionCreditStore
    {
        return $this->store;
    }

    public function getFieldDefinition(): ReductionCreditFieldDefinition
    {
        return $this->fieldDefinition;
    }

}
