<?php

namespace Lc\CaracoleBundle\Container\User;

use App\Entity\User\UserPointSale;
use Lc\CaracoleBundle\Factory\User\UserPointSaleFactory;
use Lc\CaracoleBundle\Repository\User\UserPointSaleRepositoryQuery;
use Lc\CaracoleBundle\Repository\User\UserPointSaleStore;

class UserPointSaleContainer
{
    protected UserPointSaleFactory $factory;
    protected UserPointSaleRepositoryQuery $repositoryQuery;
    protected UserPointSaleStore $store;

    public function __construct(
            UserPointSaleFactory $factory,
            UserPointSaleRepositoryQuery $repositoryQuery,
            UserPointSaleStore $store
    ) {
        $this->factory = $factory;
        $this->repositoryQuery = $repositoryQuery;
        $this->store = $store;
    }

    public static function getEntityFqcn()
    {
        return UserPointSale::class;
    }

    public function getFactory(): UserPointSaleFactory
    {
        return $this->factory;
    }

    public function getRepositoryQuery(): UserPointSaleRepositoryQuery
    {
        return $this->repositoryQuery;
    }

    public function getStore(): UserPointSaleStore
    {
        return $this->store;
    }

}
