<?php

namespace Lc\CaracoleBundle\Definition;

use Lc\CaracoleBundle\Container\Address\AddressContainer;
use Lc\CaracoleBundle\Container\Config\TaxRateContainer;
use Lc\CaracoleBundle\Container\Config\UnitContainer;
use Lc\CaracoleBundle\Container\Credit\CreditHistoryContainer;
use Lc\CaracoleBundle\Container\Distribution\DistributionContainer;
use Lc\CaracoleBundle\Container\File\DocumentContainer;
use Lc\CaracoleBundle\Container\Merchant\MerchantContainer;
use Lc\CaracoleBundle\Container\Order\OrderPaymentContainer;
use Lc\CaracoleBundle\Container\Order\OrderProductContainer;
use Lc\CaracoleBundle\Container\Order\OrderProductReductionCatalogContainer;
use Lc\CaracoleBundle\Container\Order\OrderProductRefundContainer;
use Lc\CaracoleBundle\Container\Order\OrderReductionCartContainer;
use Lc\CaracoleBundle\Container\Order\OrderReductionCreditContainer;
use Lc\CaracoleBundle\Container\Order\OrderRefundContainer;
use Lc\CaracoleBundle\Container\Order\OrderShopContainer;
use Lc\CaracoleBundle\Container\Order\OrderStatusContainer;
use Lc\CaracoleBundle\Container\Order\OrderStatusHistoryContainer;
use Lc\CaracoleBundle\Container\PointSale\PointSaleContainer;
use Lc\CaracoleBundle\Container\PointSale\PointSaleSectionContainer;
use Lc\CaracoleBundle\Container\Product\ProductCategoryContainer;
use Lc\CaracoleBundle\Container\Product\ProductContainer;
use Lc\CaracoleBundle\Container\Product\ProductFamilyContainer;
use Lc\CaracoleBundle\Container\Product\ProductFamilySectionPropertyContainer;
use Lc\CaracoleBundle\Container\Product\QualityLabelContainer;
use Lc\CaracoleBundle\Container\Reduction\ReductionCartContainer;
use Lc\CaracoleBundle\Container\Reduction\ReductionCatalogContainer;
use Lc\CaracoleBundle\Container\Reduction\ReductionCreditContainer;
use Lc\CaracoleBundle\Container\Section\OpeningContainer;
use Lc\CaracoleBundle\Container\Section\SectionContainer;
use Lc\CaracoleBundle\Container\Setting\MerchantSettingContainer;
use Lc\CaracoleBundle\Container\Setting\SectionSettingContainer;
use Lc\CaracoleBundle\Container\User\UserMerchantContainer;
use Lc\CaracoleBundle\Container\User\UserPointSaleContainer;
use Lc\CaracoleBundle\Container\User\VisitorContainer;
use Lc\SovBundle\Definition\ApplicationDefinition as SovAbstractApplicationDefinition;

class ApplicationDefinition extends SovAbstractApplicationDefinition
{

    public static function getContainerList(): array
    {
        return array_merge(parent::getContainerList(), [
                OrderShopContainer::class,
                AddressContainer::class,
                TaxRateContainer::class,
                UnitContainer::class,
                CreditHistoryContainer::class,
                DocumentContainer::class,
                MerchantContainer::class,
                OrderPaymentContainer::class,
                OrderProductContainer::class,
                OrderProductReductionCatalogContainer::class,
                OrderProductRefundContainer::class,
                OrderReductionCartContainer::class,
                OrderReductionCreditContainer::class,
                OrderRefundContainer::class,
                OrderStatusContainer::class,
                OrderStatusHistoryContainer::class,
                PointSaleContainer::class,
                ProductCategoryContainer::class,
                ProductContainer::class,
                ProductFamilyContainer::class,
                ReductionCartContainer::class,
                ReductionCatalogContainer::class,
                ReductionCreditContainer::class,
                OpeningContainer::class,
                SectionContainer::class,
                MerchantSettingContainer::class,
                SectionSettingContainer::class,
                UserMerchantContainer::class,
                UserPointSaleContainer::class,
                VisitorContainer::class,
                DistributionContainer::class,
                ProductFamilySectionPropertyContainer::class,
                QualityLabelContainer::class,
                PointSaleSectionContainer::class,
        ]);
    }

}
