<?php

namespace Lc\CaracoleBundle\Factory\Credit;

use Lc\CaracoleBundle\Container\Credit\CreditHistoryContainer;
use Lc\CaracoleBundle\Model\Credit\CreditHistoryInterface;
use Lc\CaracoleBundle\Model\User\UserMerchantInterface;
use Lc\SovBundle\Factory\AbstractFactory;

class CreditHistoryFactory extends AbstractFactory
{
    // createCreditHistory
    public function create(string $type,UserMerchantInterface $userMerchant ): CreditHistoryInterface
    {
        $creditHistory = $this->createBase($userMerchant);

        $creditHistory->setType($type) ;

        return $creditHistory;
    }

    public function createBase(UserMerchantInterface $userMerchant): CreditHistoryInterface
    {
        $class = CreditHistoryContainer::getEntityFqcn();
        $creditHistory = new $class;
        $creditHistory->setUserMerchant($userMerchant) ;
        $creditHistory->setMerchant($userMerchant->getMerchant()) ;

        return $creditHistory;
    }

}
