<?php

namespace Lc\CaracoleBundle\Model\Address;


use Lc\CaracoleBundle\Model\Merchant\MerchantInterface;
use Lc\CaracoleBundle\Model\PointSale\PointSaleInterface;
use Lc\SovBundle\Model\User\UserInterface;

interface AddressInterface
{
    public function getUser(): ?UserInterface;

    public function setUser(?UserInterface $user): AddressInterface;

    public function getTitle(): ?string;

    public function setTitle(string $title): AddressInterface;

    public function getType(): ?string;

    public function setType(string $type): AddressInterface;

    public function getCivility(): ?bool;

    public function setCivility(?bool $civility): AddressInterface;

    public function getLastname(): ?string;

    public function setLastname(?string $lastname): AddressInterface;

    public function getFirstname(): ?string;

    public function setFirstname(?string $firstname): AddressInterface;

    public function getAddress(): ?string;

    public function setAddress(string $address): AddressInterface;

    public function getZip(): ?string;

    public function setZip(string $zip): AddressInterface;

    public function getCity(): ?string;

    public function setCity(string $city): AddressInterface;

    public function getCountry(): ?string;

    public function setCountry(string $country): AddressInterface;

    public function getLatitude(): ?string;

    public function setLatitude(?string $latitude): AddressInterface;

    public function getLongitude(): ?string;

    public function setLongitude(?string $longitude): AddressInterface;

    public function getLatitudeOverride(): ?string;

    public function setLatitudeOverride(?string $latitudeOverride): AddressInterface;

    public function getLongitudeOverride(): ?string;

    public function setLongitudeOverride(?string $longitudeOverride): AddressInterface;

    public function getCompany(): ?string;

    public function setCompany(?string $company): AddressInterface;

    public function getSiret(): ?string;

    public function setSiret(?string $siret): AddressInterface;

    public function getTva(): ?string;

    public function setTva(?string $tva): AddressInterface;

    public function getPhone(): ?array;

    public function setPhone(?array $phone): AddressInterface;

    public function getComment(): ?string;

    public function setComment(?string $comment): AddressInterface;

    public function getPointSale(): ?PointSaleInterface;

    public function setPointSale(PointSaleInterface $pointSale): AddressInterface;

    public function getMerchant(): ?MerchantInterface;

    public function setMerchant(MerchantInterface $merchant): AddressInterface;

    public function getDeliveryInfos(): ?string;

    public function setDeliveryInfos(?string $deliveryInfos): AddressInterface;

    public function getCreatedBy(): ?UserInterface;

    public function setCreatedBy(?UserInterface $createdBy);

    public function getUpdatedBy(): ?UserInterface;

    public function setUpdatedBy(?UserInterface $updatedBy);

    public function getDevAlias(): ?string;

    public function setDevAlias(?string $devAlias);

    public function getStatus(): ?float;

    public function setStatus(float $status): AddressInterface;

    public function getCreatedAt(): ?\DateTimeInterface;

    public function setCreatedAt(\DateTimeInterface $createdAt);

    public function getUpdatedAt(): ?\DateTimeInterface;

    public function setUpdatedAt(\DateTimeInterface $updatedAt);
}