<?php

namespace Lc\CaracoleBundle\Model\Credit;


use Lc\CaracoleBundle\Model\Order\OrderPaymentInterface;
use Lc\CaracoleBundle\Model\Order\OrderRefundInterface;
use Lc\CaracoleBundle\Model\User\UserMerchantInterface;
use Lc\SovBundle\Model\User\UserInterface;

interface CreditHistoryInterface
{
    public function getCreatedBy(): ?UserInterface;

    public function setCreatedBy(?UserInterface $createdBy);

    public function getUpdatedBy(): ?UserInterface;

    public function setUpdatedBy(?UserInterface $updatedBy);

    public function getAmount(): ?float;

    public function setAmount(?float $amount): CreditHistoryInterface;

    public function getType(): ?string;

    public function setType(string $type): CreditHistoryInterface;

    public function getUserMerchant(): ?UserMerchantInterface;

    public function setUserMerchant(?UserMerchantInterface $userMerchant): CreditHistoryInterface;

    public function getOrderPayment(): ?OrderPaymentInterface;

    public function setOrderPayment(?OrderPaymentInterface $orderPayment): CreditHistoryInterface;

    public function getOrderRefund(): ?OrderRefundInterface;

    public function setOrderRefund(?OrderRefundInterface $orderRefund): CreditHistoryInterface;

    public function getDevAlias(): ?string;

    public function setDevAlias(?string $devAlias);

    public function setMeanPayment(?string $meanPayment): CreditHistoryInterface;

    public function getMeanPayment(): ?string;

    public function getReference(): ?string;

    public function setReference(?string $reference): CreditHistoryInterface;

    public function getPaidAt(): ?\DateTimeInterface;

    public function setPaidAt(?\DateTimeInterface $paidAt): CreditHistoryInterface;

    public function getComment(): ?string;

    public function setComment(?string $comment): CreditHistoryInterface;

    public function getCreatedAt(): ?\DateTimeInterface;

    public function setCreatedAt(\DateTimeInterface $createdAt);

    public function getUpdatedAt(): ?\DateTimeInterface;

    public function setUpdatedAt(\DateTimeInterface $updatedAt);
}