<?php

namespace Lc\CaracoleBundle\Model\Distribution;

use Doctrine\ORM\Mapping as ORM;
use Lc\SovBundle\Doctrine\EntityInterface;

/**
 * @ORM\MappedSuperclass()
 */
abstract class DistributionModel implements DistributionInterface, EntityInterface
{
    /**
     * @ORM\Column(type="integer")
     */
    protected $cycleNumber;

    /**
     * @ORM\Column(type="integer")
     */
    protected $year;

    /**
     * @ORM\Column(type="string", length=32)
     */
    protected $cycleType;

    public function __toString()
    {
        return $this->getCycleNumber() . '/' . $this->getYear();
    }

    public function getCycleNumber(): ?int
    {
        return $this->cycleNumber;
    }

    public function setCycleNumber(int $cycleNumber): self
    {
        $this->cycleNumber = $cycleNumber;

        return $this;
    }

    public function getYear(): ?int
    {
        return $this->year;
    }

    public function setYear(int $year): self
    {
        $this->year = $year;

        return $this;
    }

    public function getCycleType(): ?string
    {
        return $this->cycleType;
    }

    public function setCycleType(string $cycleType): self
    {
        $this->cycleType = $cycleType;

        return $this;
    }
}
