<?php

namespace Lc\CaracoleBundle\Model\File;


use Doctrine\Common\Collections\Collection;
use Lc\CaracoleBundle\Model\Address\AddressInterface;
use Lc\CaracoleBundle\Model\Merchant\MerchantInterface;
use Lc\CaracoleBundle\Model\Order\OrderRefundInterface;
use Lc\CaracoleBundle\Model\Order\OrderShopInterface;
use Lc\SovBundle\Model\User\UserInterface;


interface DocumentInterface
{
    public function getTitle(): ?string;

    public function setTitle(string $title);

    public function getDescription(): ?string;

    public function setDescription(?string $description);

    public function getCreatedBy(): ?UserInterface;

    public function setCreatedBy(?UserInterface $createdBy);

    public function getUpdatedBy(): ?UserInterface;

    public function setUpdatedBy(?UserInterface $updatedBy);

    public function getDevAlias(): ?string;

    public function setDevAlias(?string $devAlias);

    public function getMerchant(): ?MerchantInterface;

    public function setMerchant(?MerchantInterface $merchant): DocumentInterface;

    public function getLabel();

    public function getType(): ?string;

    public function setType(string $type): DocumentInterface;

    public function getReference(): ?string;

    public function setReference(?string $reference): DocumentInterface;

    public function getLogo(): ?string;

    public function setLogo(string $logo): DocumentInterface;

    public function getMerchantAddress(): ?AddressInterface;

    public function setMerchantAddress(?AddressInterface $merchantAddress): DocumentInterface;

    public function getBuyerAddress(): ?AddressInterface;

    public function setBuyerAddress(?AddressInterface $buyerAddress): DocumentInterface;

    public function getMerchantAddressText(): ?string;

    public function setMerchantAddressText(string $merchantAddressText): DocumentInterface;

    public function getBuyerAddressText(): ?string;

    public function setBuyerAddressText(?string $buyerAddressText): DocumentInterface;

    public function getDeliveryAddressText(): ?string;

    public function setDeliveryAddressText(?string $deliveryAddressText): DocumentInterface;

    public function getIsSent(): ?bool;

    public function setIsSent(?bool $isSent): DocumentInterface;

    /**
     * @return Collection|OrderShopInterface[]
     */
    public function getOrderShops(): Collection;

    public function addOrderShop(OrderShopInterface $orderShop): DocumentInterface;

    public function removeOrderShop(OrderShopInterface $orderShop): DocumentInterface;

    public function getOrderRefund(): ?OrderRefundInterface;

    public function setOrderRefund(OrderRefundInterface $orderRefund): DocumentInterface;

    public function getMetaTitle(): ?string;

    public function setMetaTitle(?string $metaTitle);

    public function getMetaDescription(): ?string;

    public function setMetaDescription(?string $metaDescription);

    public function setOldUrls($oldUrls);

    public function getOldUrls(): ?array;

    public function getSlug(): ?string;

    public function setSlug(?string $slug);

    public function getPosition(): float;

    public function setPosition(float $position);

    public function clearPosition();

    public function getStatus(): ?float;

    public function setStatus(float $status);

    public function getCreatedAt(): ?\DateTimeInterface;

    public function setCreatedAt(\DateTimeInterface $createdAt);

    public function getUpdatedAt(): ?\DateTimeInterface;

    public function setUpdatedAt(\DateTimeInterface $updatedAt);
}