<?php

namespace Lc\CaracoleBundle\Model\Newsletter;

use Doctrine\ORM\Mapping as ORM;
use Lc\CaracoleBundle\Doctrine\Extension\FilterSectionInterface;
use Lc\CaracoleBundle\Model\Section\SectionInterface;
use Lc\SovBundle\Model\Newsletter\NewsletterModel as SovNewsletterModel;

/**
 * @ORM\MappedSuperclass()
 */
abstract class NewsletterModel extends SovNewsletterModel implements FilterSectionInterface
{
    /**
     * @ORM\ManyToOne(targetEntity="Lc\CaracoleBundle\Model\Section\SectionInterface", inversedBy="newsletters")
     */
    protected $section;

    public function __toString()
    {
        return $this->getTitle(). ' - '.$this->getSection()->getMerchant()->getTitle();
    }

    public function getSection(): SectionInterface
    {
        return $this->section;
    }

    public function setSection(?SectionInterface $section): self
    {
        $this->section = $section;

        return $this;
    }
}
