<?php

namespace Lc\CaracoleBundle\Model\Order;


use Lc\CaracoleBundle\Model\Config\TaxRateInterface;
use Lc\CaracoleBundle\Model\Config\UnitInterface;
use Lc\CaracoleBundle\Model\Product\ProductInterface;

interface OrderProductInterface
{
    public function getOrderShop(): ?OrderShopInterface;

    public function setOrderShop(?OrderShopInterface $orderShop): OrderProductInterface;

    public function getProduct(): ?ProductInterface;

    public function setProduct(?ProductInterface $product): OrderProductInterface;

    public function getQuantityOrder(): ?int;

    public function setQuantityOrder(int $quantityOrder): OrderProductInterface;

    public function getQuantityProduct(): ?float;

    public function setQuantityProduct(float $quantityProduct): OrderProductInterface;

    public function getTitle(): ?string;

    public function setTitle(string $title): OrderProductInterface;

    public function getOrderProductReductionCatalog(): ?OrderProductReductionCatalogInterface;

    public function setOrderProductReductionCatalog(?OrderProductReductionCatalogInterface $orderProductReductionCatalog
    ): OrderProductInterface;

    public function getPriceInherited(): ?float;

    public function getUnitInherited(): ?UnitInterface;

    public function getTaxRateInherited(): ?TaxRateInterface;

    public function getBuyingPriceInherited(): ?float;

    public function getBuyingPrice(): ?float;

    public function setBuyingPrice(?float $buyingPrice): OrderProductInterface;

    public function getPrice(): ?float;

    public function setPrice(?float $price): OrderProductInterface;

    public function getUnit(): ?UnitInterface;

    public function setUnit(?UnitInterface $unit): OrderProductInterface;

    public function getTaxRate(): ?TaxRateInterface;

    public function setTaxRate(?TaxRateInterface $taxRate): OrderProductInterface;
}