<?php

namespace Lc\CaracoleBundle\Model\PointSale;

use Doctrine\ORM\Mapping as ORM;
use Lc\CaracoleBundle\Doctrine\Extension\OrderAmountMinTrait;
use Lc\CaracoleBundle\Model\Section\SectionInterface;
use Lc\SovBundle\Doctrine\EntityInterface;

/**
 * @ORM\MappedSuperclass()
 */
abstract class PointSaleSectionModel implements EntityInterface, PointSaleSectionInterface
{
    /**
     * @ORM\ManyToOne(targetEntity="Lc\CaracoleBundle\Model\Section\SectionInterface", inversedBy="pointSaleSections")
     * @ORM\JoinColumn(nullable=false)
     */
    protected $section;

    /**
     * @ORM\ManyToOne(targetEntity="Lc\CaracoleBundle\Model\PointSale\PointSaleInterface", inversedBy="pointSaleSections")
     * @ORM\JoinColumn(nullable=false)
     */
    protected $pointSale;


    /**
     * @ORM\Column(type="float", nullable=true)
     */
    protected $orderAmountMin;

    public function getSection(): SectionInterface
    {
        return $this->section;
    }

    public function setSection(SectionInterface $section): self
    {
        $this->section = $section;

        return $this;
    }

    public function getPointSale(): PointSaleInterface
    {
        return $this->pointSale;
    }

    public function setPointSale(PointSaleInterface $pointSale): self
    {
        $this->pointSale = $pointSale;

        return $this;
    }

    public function getOrderAmountMin(): ?float
    {
        return $this->orderAmountMin;
    }

    public function setOrderAmountMin(?float $orderAmountMin): self
    {
        $this->orderAmountMin = $orderAmountMin;

        return $this;
    }
}
