<?php

namespace Lc\CaracoleBundle\Model\Product;


use Doctrine\Common\Collections\Collection;
use Lc\CaracoleBundle\Model\Section\SectionInterface;
use Lc\SovBundle\Model\File\FileInterface;
use Lc\SovBundle\Model\User\UserInterface;

interface ProductCategoryInterface
{
    public function getTitle(): ?string;

    public function setTitle(string $title);

    public function getDescription(): ?string;

    public function setDescription(?string $description);

    public function getCreatedBy(): ?UserInterface;

    public function setCreatedBy(?UserInterface $createdBy);

    public function getUpdatedBy(): ?UserInterface;

    public function setUpdatedBy(?UserInterface $updatedBy);

    public function getDevAlias(): ?string;

    public function setDevAlias(?string $devAlias);

    public function getSection(): SectionInterface;

    public function setSection(SectionInterface $section): ProductCategoryInterface;

    public function getParent(): ?ProductCategoryInterface;

    public function setParent(?ProductCategoryInterface $productCategory): ProductCategoryInterface;

    public function getParentCategory();

    public function getChildrens(): Collection;

    public function addChildren(ProductCategoryInterface $productCategory): ProductCategoryInterface;

    public function removeChildren(ProductCategoryInterface $productCategory): ProductCategoryInterface;

    /**
     * @return Collection|ProductFamilyInterface[]
     */
    public function getProductFamilies(): Collection;

    public function addProductFamily(ProductFamilyInterface $productFamily
    ): ProductCategoryInterface;

    public function removeProductFamily(ProductFamilyInterface $productFamily
    ): ProductCategoryInterface;

    public function countProductFamilies($status = null);

    public function getSaleStatus(): ?bool;

    public function setSaleStatus(bool $saleStatus): ProductCategoryInterface;

    public function getImage(): ?FileInterface;

    public function setImage(?FileInterface $image): ProductCategoryInterface;

    public function getMetaTitle(): ?string;

    public function setMetaTitle(?string $metaTitle);

    public function getMetaDescription(): ?string;

    public function setMetaDescription(?string $metaDescription);

    public function setOldUrls($oldUrls);

    public function getOldUrls(): ?array;

    public function getSlug(): ?string;

    public function setSlug(?string $slug);

    public function getPosition(): float;

    public function setPosition(float $position);

    public function clearPosition();

    public function getStatus(): ?float;

    public function setStatus(float $status);

    public function getCreatedAt(): ?\DateTimeInterface;

    public function setCreatedAt(\DateTimeInterface $createdAt);

    public function getUpdatedAt(): ?\DateTimeInterface;

    public function setUpdatedAt(\DateTimeInterface $updatedAt);
}