<?php

namespace Lc\CaracoleBundle\Model\Reduction;


use Doctrine\Common\Collections\Collection;
use Lc\CaracoleBundle\Model\Merchant\MerchantInterface;
use Lc\SovBundle\Model\User\UserInterface;

interface ReductionCreditInterface
{
    public function getCreatedBy(): ?UserInterface;

    public function setCreatedBy(?UserInterface $createdBy);

    public function getUpdatedBy(): ?UserInterface;

    public function setUpdatedBy(?UserInterface $updatedBy);

    public function getDevAlias(): ?string;

    public function setDevAlias(?string $devAlias);

    public function getTitle(): ?string;

    public function setTitle(string $title): ReductionCreditInterface;

    public function getMerchant(): MerchantInterface;

    public function setMerchant(MerchantInterface $merchant): ReductionCreditInterface;

    public function getType(): ?string;

    public function setType(string $type): ReductionCreditInterface;

    /**
     * @return Collection|UserInterface[]
     */
    public function getUsers(): Collection;

    public function addUser(UserInterface $user): ReductionCreditInterface;

    public function removeUser(UserInterface $user): ReductionCreditInterface;

    public function getSended(): ?bool;

    public function setSended(?bool $sended): ReductionCreditInterface;

    public function getOwner(): ?UserInterface;

    public function setOwner(?UserInterface $owner): ReductionCreditInterface;

    public function getActivationDate(): ?\DateTimeInterface;

    public function setActivationDate(?\DateTimeInterface $activationDate
    ): ReductionCreditInterface;

    public function getOwnerName(): ?string;

    public function setOwnerName(?string $ownerName): ReductionCreditInterface;

    public function getOwnerMessage(): ?string;

    public function setOwnerMessage(?string $ownerMessage): ReductionCreditInterface;

    public function getValue(): ?float;

    public function setValue(?float $value): ReductionCreditInterface;

    public function getUnit(): ?string;

    public function setUnit(?string $unit): ReductionCreditInterface;

    public function getBehaviorTaxRate(): ?string;

    public function setBehaviorTaxRate(?string $behaviorTaxRate
    ): ReductionCreditInterface;

    public function getStatus(): ?float;

    public function setStatus(float $status): ReductionCreditInterface;

    public function getCreatedAt(): ?\DateTimeInterface;

    public function setCreatedAt(\DateTimeInterface $createdAt
    );

    public function getUpdatedAt(): ?\DateTimeInterface;

    public function setUpdatedAt(\DateTimeInterface $updatedAt
    );
}