<?php

namespace Lc\CaracoleBundle\Model\User;


use Doctrine\Common\Collections\Collection;
use Lc\CaracoleBundle\Model\Credit\CreditHistoryInterface;
use Lc\CaracoleBundle\Model\Merchant\MerchantInterface;
use Lc\CaracoleBundle\Model\Section\SectionInterface;

interface UserMerchantInterface
{
    public function getUser(): ?UserModel;

    public function setUser(?UserModel $user): UserMerchantInterface;

    public function getMerchant(): ?MerchantInterface;

    public function setMerchant(?MerchantInterface $merchant): UserMerchantInterface;

    public function getCurrentAdminSection(): ?SectionInterface;

    public function setCurrentAdminSection(?SectionInterface $currentAdminSection
    ): UserMerchantInterface;

    public function getCredit(): ?float;

    public function setCredit(?float $credit): UserMerchantInterface;

    public function getCreditActive(): ?bool;

    public function isCreditActive(): bool;

    public function setCreditActive(bool $creditActive): UserMerchantInterface;

    /**
     * @return Collection|CreditHistoryInterface[]
     */
    public function getCreditHistories(): Collection;

    public function addCreditHistory(CreditHistoryInterface $creditHistory
    ): UserMerchantInterface;

    public function removeCreditHistory(CreditHistoryInterface $creditHistory
    ): UserMerchantInterface;

    public function getActive(): ?bool;

    public function setActive(bool $active): UserMerchantInterface;

    public function getRoles(): array;

    public function setRoles(array $roles): UserMerchantInterface;

    public function hasRole($role);
}