<?php

namespace Lc\CaracoleBundle\Model\User;

use Doctrine\ORM\Mapping as ORM;
use Lc\CaracoleBundle\Model\PointSale\PointSaleInterface;
use Lc\SovBundle\Doctrine\EntityInterface;
use Lc\SovBundle\Model\User\UserInterface;

/**
 * @ORM\MappedSuperclass
 */
abstract class UserPointSaleModel implements UserPointSaleInterface, EntityInterface
{
    /**
     * @ORM\ManyToOne(targetEntity="Lc\SovBundle\Model\User\UserInterface", inversedBy="userPointSales")
     * @ORM\JoinColumn(nullable=false)
     */
    protected $user;

    /**
     * @ORM\ManyToOne(targetEntity="Lc\CaracoleBundle\Model\PointSale\PointSaleInterface", inversedBy="userPointSales")
     * @ORM\JoinColumn(nullable=false)
     */
    protected $pointSale;

    /**
     * @ORM\Column(type="text", nullable=true)
     */
    protected $comment;

    public function getUser(): ?UserInterface
    {
        return $this->user;
    }

    public function setUser(?UserInterface $user): self
    {
        $this->user = $user;

        return $this;
    }

    public function getPointSale(): ?PointSaleInterface
    {
        return $this->pointSale;
    }

    public function setPointSale(?PointSaleInterface $pointSale): self
    {
        $this->pointSale = $pointSale;

        return $this;
    }

    public function getComment(): ?string
    {
        return $this->comment;
    }

    public function setComment(?string $comment): self
    {
        $this->comment = $comment;

        return $this;
    }
}
