<?php

namespace Lc\CaracoleBundle\Model\User;


use Doctrine\Common\Collections\Collection;
use Lc\CaracoleBundle\Model\Order\OrderShopInterface;

interface VisitorInterface
{
    public function getSummary();

    public function getCookie(): ?string;

    public function setCookie(?string $cookie): VisitorInterface;

    public function getLastAccess(): ?\DateTimeInterface;

    public function setLastAccess(\DateTimeInterface $lastAccess): VisitorInterface;

    public function getIp(): ?string;

    public function setIp(?string $ip): VisitorInterface;

    public function getTotalVisit(): ?int;

    public function setTotalVisit(int $totalVisit): VisitorInterface;

    /**
     * @return Collection|OrderShopInterface[]
     */
    public function getOrders(): Collection;

    public function addOrder(OrderShopInterface $order): VisitorInterface;

    public function removeOrder(OrderShopInterface $order): VisitorInterface;
}