<?php

namespace Lc\CaracoleBundle\Repository\PointSale;

use Knp\Component\Pager\PaginatorInterface;
use Lc\CaracoleBundle\Model\PointSale\PointSaleInterface;
use Lc\CaracoleBundle\Repository\SectionRepositoryQueryTrait;
use Lc\SovBundle\Repository\AbstractRepositoryQuery;

class PointSaleSectionRepositoryQuery extends AbstractRepositoryQuery
{
    use SectionRepositoryQueryTrait;

    public function __construct(PointSaleSectionRepository $repository, PaginatorInterface $paginator)
    {
        parent::__construct($repository, 'pointSaleSection', $paginator);
    }

    public function filterByPointSale(PointSaleInterface $pointSale): self
    {
        return $this->andWhereEqual('pointSale', $pointSale);
    }
}
