<?php

namespace Lc\CaracoleBundle\Repository\Section;

use Knp\Component\Pager\PaginatorInterface;
use Lc\CaracoleBundle\Repository\MerchantRepositoryQueryTrait;
use Lc\SovBundle\Repository\AbstractRepositoryQuery;

class SectionRepositoryQuery extends AbstractRepositoryQuery
{
    use MerchantRepositoryQueryTrait;

    public function __construct(SectionRepository $repository, PaginatorInterface $paginator)
    {
        parent::__construct($repository, 'section', $paginator);
    }

    public function filterByIsDefault(bool $isDefault)
    {
        return $this->andWhereEqual('isDefault', $isDefault);
    }

    public function filterIsOnlineFrontend()
    {
        return $this->filterIsOnline()
                && $this->andWhereEqual('isOnlineFrontend', true);
    }

}
