<?php

namespace Lc\CaracoleBundle\Solver\Order;

use Lc\CaracoleBundle\Model\Order\OrderProductReductionCatalogInterface;

class OrderProductReductionCatalogSolver
{
    // getSummaryOrderProductReductionCatalog
    public function getSummary(OrderProductReductionCatalogInterface $orderProductReductionCatalog): string
    {
        $text = '';

        if ($orderProductReductionCatalog->getUnit() == 'amount') {
            $text .= '- ' . number_format($orderProductReductionCatalog->getValue(),2) . '&nbsp;€';
        }

        if ($orderProductReductionCatalog->getUnit() == 'percent') {
            $text .= '- ' . number_format($orderProductReductionCatalog->getValue(),2) . '&nbsp;%';
        }

        return $text;
    }

    // compareOrderProductReductionCatalog
    public function compare(
            OrderProductReductionCatalogInterface $orderProductReductionCatalog = null,
            OrderProductReductionCatalogInterface $orderProductReductionCatalogCompare = null
    ): bool {

        if(is_null($orderProductReductionCatalog) && is_null($orderProductReductionCatalogCompare)) {
            return true;
        }

        if(is_null($orderProductReductionCatalog) || is_null($orderProductReductionCatalogCompare)) {
            return false;
        }

        return $orderProductReductionCatalog->getUnit() == $orderProductReductionCatalogCompare->getUnit()
                && (string)$orderProductReductionCatalog->getValue(
                ) == (string)$orderProductReductionCatalogCompare->getValue()
                && $orderProductReductionCatalog->getBehaviorTaxRate(
                ) == $orderProductReductionCatalogCompare->getBehaviorTaxRate();
    }
}